# Description:
#  Accorcia un link usando l'api di brve.bit
#
# Dependencies:
#   valid-url
#   needle
#
# Configuration:
#   None
#
# Commands:
#   hubot accorcia/breve <url> - accorcia un link
#
# Author:
#   Michele Guerini Rocco (rnhmjoj)
#

ne             = require 'needle'
{ is_web_uri } = require 'valid-url'

valid   = ['eccoti: ', 'ecco qui: ', 'fatto: ', '']
invalid = ['eh?', "cos'è sta roba?", 'sarebbe un url questo?']

module.exports = (robot) ->
  robot.respond /breve|accorcia (.+)$/i, (res) ->
    url = res.match[1]
    if is_web_uri url
       ne.post 'https://brve.bit/api', url: url, {rejectUnauthorized: false}, (err, resp, body) =>
        return res.send "c'è qualche problema: #{err}" if err
        res.send (res.random valid) + body.link
    else
      res.send res.random invalid
